
#include <stdio.h>

#include "COM.h"



#define ENQ	0x05
#define EOT	0x04


void main (int argc, char* argv[])
{
 FILE* file;
 int port;
 char buffer[1024];
 int n;

 if (argc != 2)
   {
    printf("Uso: RIC nome-file\r\n");
    return;
   }

 file = fopen(argv[1],"wt");
 if (file == NULL)
   {
    printf("Fallimento apertura file\r\n");
    return;
   }

 if ((long)(port = COM_open(0, READ_WRITE, 9600, 'n', 8, 1, NO_HANDSHAKE)) < 0)
   {
    printf("Fallimento apertura porta seriale\r\n");
    return;
   }

 buffer[0] = ENQ;
 while (1) // ciclo di attesa carattere ENQ
      {
	     COM_write(port, buffer, 1);
	     if ((n = COM_read(port, buffer, 1)) > 0)
	       break;
      }
       	
 fwrite(buffer, n, 1, file);
 while (1)
      {
       n = COM_read(port, buffer, sizeof(buffer));
	     if (n > 0)
	       {
		      buffer[n] = '\0';
		      printf("%s", buffer);
		      fwrite(buffer, n, 1, file);
		      if (buffer[n-1] == EOT)
            break;
         }
       }

 COM_close(port);
 fclose(file);
}
