
#include <stdio.h>

#include "COM.h"


#define STX	0x02
#define ETX	0x03
#define EOT	0x04


void main (int argc, char* argv[])
{
 FILE* file;
 HANDLE com;
 char buffer[256], data[256];
 int i, n, p;

 if (argc != 2)
   {
    printf("Uso: RX nome-file\r\n");
    return;
   }

 file = fopen(argv[1],"wt");
 if (file == NULL)
   {
    printf("Fallimento apertura file\r\n");
    return;
   }

 if ((long)(com = COM_open(1, READ_WRITE, 9600, 'n', 8, 1, NO_HANDSHAKE)) < 0)
   {
    printf("Fallimento apertura porta seriale\r\n");
    return;
   }

 while (1)
      {
       n = COM_read(com, buffer, sizeof(buffer)); // ricezione
       if (n > 0)
	     {
          for (i=0; i<n; i++) // ricerca caratteri iniziale/finale
		     {
			  if (buffer[i] == STX) // carattere iniziale pacchetto
				{
				 data[0] = buffer[i];
				 p = 1;
				}
			  else
			      {
				   if (buffer[i] == ETX) // carattere finale pacchetto
				     {
					  if (data[0] == STX)
						{
						 data[p] = '\0';
		                 printf("%s", &data[1]);
		                 fwrite(&data[1], p-1, 1, file);
		                }
					  p = 0;
					 }
				   else
					   {
					    if (buffer[i] == EOT) // fine trasmissione
						  {
						   fclose(file);
						   COM_close(com);
						   return;
						  }
						else
						    {
					         data[p] = buffer[i]; // copia carattere
					         p++;
						    }
					   }
				  }
			 } // fine ciclo for
	     }
      } // fine ciclo while
}
