
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

#include "COM.h"

#define START	127
#define STOP	255

struct METEO
{
 char start;
 signed char temperature;
 unsigned char humidity;
 signed char pressure;
 unsigned char wind_speed;
 char stop;
};


void main(void)
{
 int com;
 struct METEO meteo;

 meteo.start = START;
 meteo.stop = STOP;

 // apertura porta seriale
 if ((com = COM_open(0, WRITE, 9600, 'N', 8, 1, NO_HANDSHAKE)) > 0)
   {
    while (1)
         {
          meteo.temperature = (signed char)(((float)rand()/RAND_MAX)*100-40);
		      meteo.humidity = (unsigned char)(((float)rand()/RAND_MAX)*100);
		      meteo.pressure = (signed char)(((float)rand()/RAND_MAX)*75-25);
		      meteo.wind_speed = (unsigned char)(((float)rand()/RAND_MAX)*150);
		      COM_write(com, (char*)&meteo, sizeof(meteo)); // trasmissione
		      sleep(60); // 60s
         }
   }
 else
     printf("Errore apertura porta seriale\r\n");
}
